import base64
import sys


if sys.version_info.major == 2:
    text_type = unicode
else:
    text_type = str


class BadData(Exception):
    pass


def want_bytes(s, encoding="utf-8", errors="strict"):
    if isinstance(s, text_type):
        s = s.encode(encoding, errors)
    return s


def base64_encode(s):
    s = want_bytes(s)
    return base64.urlsafe_b64encode(s).rstrip(b"=")


def base64_decode(s):
    s = want_bytes(s, encoding="ascii", errors="ignore")
    s += b"=" * (-len(s) % 4)

    try:
        return base64.urlsafe_b64decode(s)
    except (TypeError, ValueError):
        raise BadData("Invalid base64-encoded data")
