import pytest

from example.encoding import BadData
from example.encoding import base64_decode
from example.encoding import base64_encode
from example.encoding import want_bytes


@pytest.mark.parametrize("value", (u"hello", b"world"))
def test_base64(value):
    data = base64_encode(value)
    assert isinstance(data, bytes)
    out = base64_decode(data)
    assert out == want_bytes(value)


def test_base64_bad_data():
    with pytest.raises(BadData):
        base64_decode("a")
